<?php
require('wp-config.php');

// XML header
echo '<?xml version="1.0" encoding="utf-8"?>' . "\n";

// urlset
echo '<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9"
				xmlns:news="http://www.google.com/schemas/sitemap-news/0.9">' . "\n";

// Select posts; set limit 20
$rows = $wpdb->get_results("SELECT DISTINCT ID, post_date_gmt
                            FROM $wpdb->posts, $wpdb->term_relationships, $wpdb->term_taxonomy
                            WHERE $wpdb->term_relationships.object_id = $wpdb->posts.id
                            AND post_status = 'publish'
                            AND post_type = 'post'
                            AND $wpdb->term_taxonomy.term_taxonomy_id = $wpdb->term_relationships.term_taxonomy_id
                            AND $wpdb->term_taxonomy.taxonomy = 'category'
                            AND $wpdb->term_taxonomy.term_id = 7
                            ORDER BY $wpdb->posts.post_date_gmt DESC
                            LIMIT 0, 20");

// sitemap data
foreach ($rows as $row) {
	echo "\t" . '<url>' . "\n";
	echo "\t\t" . '<loc>';
	echo get_permalink($row->ID);
	echo '</loc>' . "\n";
	echo "\t\t" . '<news:news>' . "\n";
	echo "\t\t" . '<news:publication_date>';
	$thedate  = substr($row->post_date_gmt, 0, 10);
	$thetime  = substr($row->post_date_gmt, 11, 20);
	echo $thedate . 'T' . $thetime . 'Z';
	echo '</news:publication_date>' . "\n";
	$tags     = wp_get_post_tags( $row->ID, array('fields' => 'all') );
	$tagcount = count($tags);
	echo "\t\t" . '<news:keywords>';
	for ($i = 1; $i < $tagcount; $i++) {
		echo $taglist  = str_replace( "'", '', str_replace( '"', '', urldecode($tags[$i]->name) ) );
		if ( $i != $tagcount-1 )
		 echo ', ';
	}
	echo '</news:keywords>' . "\n";
	echo "\t\t" . '</news:news>' . "\n";
	echo "\t" . '</url>' . "\n";
}

// End urlset
echo '</urlset>';
?>